commit e77ff2bf93a602e963758496195c35327e2e36ac
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Thu Jul 25 12:21:48 2024 +0530

    PS-9301 Spatial index issues
    
    https://perconadev.atlassian.net/browse/PS-9301
    
    mysql/mysql-server@132b094b046
    
    Bug#35894664: Assertion in Bitmap<64>::is_set(uint)
                  when forcing a spatial index scan.
    Bug#36361834: Incorrect result of getting data from a
                  spatial index on column with SRID
    Bug#36366621: MySQL crash when explaining a force a
                  spatial index containing column with SRID
    
    Bug#36361834:
    While setting up keys that could be used for covering
    index scans, a "geometry" keypart makes an index not
    covering. However, in case of innodb, a secondary index
    is always extended with primary key. While setting up
    the extended keypart spatial index is marked as covering.
    With force index in effect, spatial index is the only
    available index for optimizer to choose from. It picks
    "index-skip-scan" for the table. However, innodb does
    not support sequential scans on spatial indexes. This
    leads to wrong results with no rows retrieved.
    
    Bug#35894664 and Bug#36366621:
    When choosing covering index scans, optimizer picks
    the shortest covering key available. However, for
    the case where spatial index is the only available
    option, it fails to pick any index to do the index
    scan which leads to problems later.
    
    Solution to all these issues is that spatial indexes
    should not be marked as indexes that could be used
    for index only reads. There are a few inconsistencies
    in the code w.r.t this. So we try to correct them.
    While setting up keyparts, "geometry" field
    makes the index not covering but having an extended
    keypart which is not a geometry field makes the index
    covering which should not be the case. So we now disable
    spatial index for "index-only" reads irrespective of the
    extended keyparts.
    
    Change-Id: I44c04f79f35a270087a01c962f9ad35f5e3ad534

diff --git a/mysql-test/suite/gis/r/spatial_index_data.result b/mysql-test/suite/gis/r/spatial_index_data.result
new file mode 100644
index 00000000000..7ab96444552
--- /dev/null
+++ b/mysql-test/suite/gis/r/spatial_index_data.result
@@ -0,0 +1,14 @@
+CREATE TABLE `tab` (
+`id` INT AUTO_INCREMENT NOT NULL,
+`shape` GEOMETRY NOT NULL /*!80003 SRID 0 */,
+PRIMARY KEY (`id`),
+SPATIAL KEY (`shape`)
+) ENGINE=InnoDB;
+INSERT INTO tab VALUES (2, POINT(1,100));
+SELECT id FROM tab FORCE INDEX (primary) WHERE id > 0;
+id
+2
+SELECT id FROM tab FORCE INDEX (shape) WHERE id > 0;
+id
+2
+DROP TABLE tab;
diff --git a/mysql-test/suite/gis/r/spatial_index_explain.result b/mysql-test/suite/gis/r/spatial_index_explain.result
new file mode 100644
index 00000000000..cd642b762f8
--- /dev/null
+++ b/mysql-test/suite/gis/r/spatial_index_explain.result
@@ -0,0 +1,13 @@
+CREATE TABLE `tab` (
+`id` INT AUTO_INCREMENT NOT NULL,
+`shape` GEOMETRY NOT NULL /*!80003 SRID 0 */,
+PRIMARY KEY (`id`),
+SPATIAL KEY (`shape`)
+) ENGINE=InnoDB;
+INSERT INTO tab VALUES (2, POINT(1,100));
+EXPLAIN SELECT id FROM tab FORCE INDEX (shape);
+id	select_type	table	partitions	type	possible_keys	key	key_len	ref	rows	filtered	Extra
+1	SIMPLE	tab	NULL	ALL	NULL	NULL	NULL	NULL	1	100.00	NULL
+Warnings:
+Note	1003	/* select#1 */ select `test`.`tab`.`id` AS `id` from `test`.`tab` FORCE INDEX (`shape`)
+DROP TABLE tab;
diff --git a/mysql-test/suite/gis/t/spatial_index_data.test b/mysql-test/suite/gis/t/spatial_index_data.test
new file mode 100644
index 00000000000..d75e5adf13a
--- /dev/null
+++ b/mysql-test/suite/gis/t/spatial_index_data.test
@@ -0,0 +1,18 @@
+#################################################################
+# TEST IF USING SPATIAL INDEX ON COLUMN RETURNS CORRECT RESULTS #
+#################################################################
+
+CREATE TABLE `tab` (
+  `id` INT AUTO_INCREMENT NOT NULL,
+  `shape` GEOMETRY NOT NULL /*!80003 SRID 0 */,
+  PRIMARY KEY (`id`),
+  SPATIAL KEY (`shape`)
+) ENGINE=InnoDB;
+
+INSERT INTO tab VALUES (2, POINT(1,100));
+
+SELECT id FROM tab FORCE INDEX (primary) WHERE id > 0;
+
+SELECT id FROM tab FORCE INDEX (shape) WHERE id > 0;
+
+DROP TABLE tab;
diff --git a/mysql-test/suite/gis/t/spatial_index_explain.test b/mysql-test/suite/gis/t/spatial_index_explain.test
new file mode 100644
index 00000000000..f2b16e9b804
--- /dev/null
+++ b/mysql-test/suite/gis/t/spatial_index_explain.test
@@ -0,0 +1,16 @@
+###############################################################################
+# TEST IF MYSQL CRASHES WHEN EXPLAINING WITH A FORCE INDEX ON A SPATIAL INDEX #
+###############################################################################
+
+CREATE TABLE `tab` (
+  `id` INT AUTO_INCREMENT NOT NULL,
+  `shape` GEOMETRY NOT NULL /*!80003 SRID 0 */,
+  PRIMARY KEY (`id`),
+  SPATIAL KEY (`shape`)
+) ENGINE=InnoDB;
+
+INSERT INTO tab VALUES (2, POINT(1,100));
+
+EXPLAIN SELECT id FROM tab FORCE INDEX (shape);
+
+DROP TABLE tab;
diff --git a/sql/sql_optimizer.cc b/sql/sql_optimizer.cc
index 84c9f8dda07..189e9f70cd4 100644
--- a/sql/sql_optimizer.cc
+++ b/sql/sql_optimizer.cc
@@ -1639,12 +1639,15 @@ uint find_shortest_key(TABLE *table, const key_map *usable_keys)
       if (usable_keys->is_set(nr))
       {
         /*
-          Can not do full index scan on rtree index because it is not
-          supported by Innodb, probably not supported by others either.
+          Cannot do full index scan on rtree index. It is not supported by
+          Innodb as it's rtree index does not store data, but only the
+          minimum bouding box (maybe makes sense only for geometries of
+          type POINT). Index scans on rtrees are probabaly not supported
+          by other storage engines either.
          */
         const KEY &key_ref= table->key_info[nr];
-        if (key_ref.key_length < min_length &&
-            !(key_ref.flags & HA_SPATIAL))
+        assert(!(key_ref.flags & HA_SPATIAL));
+        if (key_ref.key_length < min_length)
         {
           min_length=key_ref.key_length;
           best=nr;
diff --git a/sql/table.cc b/sql/table.cc
index d469b12a301..436fffb6507 100644
--- a/sql/table.cc
+++ b/sql/table.cc
@@ -973,7 +973,8 @@ static void setup_key_part_field(TABLE_SHARE *share, handler *handler_file,
   if (field->key_length() == key_part->length &&
       !(field->flags & BLOB_FLAG))
   {
-    if (handler_file->index_flags(key_n, key_part_n, 0) & HA_KEYREAD_ONLY)
+    if ((handler_file->index_flags(key_n, key_part_n, 0) & HA_KEYREAD_ONLY) &&
+        !(keyinfo->flags & HA_SPATIAL))
     {
       share->keys_for_keyread.set_bit(key_n);
       field->part_of_key.set_bit(key_n);

